% Exemple de classe de DEA construite au-dessus de thloria.
%
\NeedsTeXFormat{LaTeX2e}[1997/12/01]

\ProvidesClass{memcril}[2009/09/09 v0.3 (B. Mazure, CRIL))]

\RequirePackage{ifthen}


\newcounter{nboption}

\newboolean{optionedoc}
\newboolean{thdoc}
\newboolean{hdrdoc}
\newboolean{m1doc}
\newboolean{m2iadoc}
\newboolean{m2ilidoc}
\newboolean{m2iljdoc}
\DeclareOption{th}{\setboolean{thdoc}{true}\stepcounter{nboption}}
\DeclareOption{hdr}{\setboolean{hdrdoc}{true}\stepcounter{nboption}}
\DeclareOption{m1}{\setboolean{m1doc}{true}\stepcounter{nboption}}
\DeclareOption{m2ia}{\setboolean{m2iadoc}{true}\stepcounter{nboption}}
\DeclareOption{m2ili}{\setboolean{m2ilidoc}{true}\stepcounter{nboption}}
\DeclareOption{m2ilj}{\setboolean{m2iljdoc}{true}\stepcounter{nboption}}
\DeclareOption{edoc}{\setboolean{optionedoc}{true}}
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{thloria}}
\ProcessOptions

\RequirePackage[utf8]{inputenc}
\RequirePackage[T1]{fontenc}         %% Guillemets françaises
\RequirePackage{times}

\LoadClass[openany,11pt]{thloria}

%%%%%%%%%%%%%%%%% PREMIERE SOLUTION COMPILATION LATEX
% Pour les figures (eps,jpeg,gif,png,tiff,pdf)
\RequirePackage[]{graphicx}
% Patch \Gin@setfile to execute #3, if it contains
% a command
\let\orgGin@setfile\Gin@setfile
\def\Gin@setfile#1#2#3{%
  \if`\@car #3\relax\@nil
    \immediate\write18{\@cdr #3\@empty\@nil}%
    \orgGin@setfile{#1}{#2}{\Gin@base #2}%
  \else
    \orgGin@setfile{#1}{#2}{#3}%
  \fi
}
\catcode\lq\`=12
\gdef\@p@ndor@{Lhrd*dm*o`fd*`udb*ldlbqhk*'A-*L`ytqd+*BQHK(*ds*sgknqh`*'C-*Qndfdk+*KNQH@(-}
% Adding .eps at the end of the list of extensions,
% defined by \DeclareGraphicsExtensions
\g@addto@macro\Gin@extensions{,.pdf}
% \DeclareGraphicsRule for .pdf
\@namedef{Gin@rule@.pdf}#1{{eps}{.eps}{`pdftops -eps #1}}
% \DeclareGraphicsRule for .jpg
\g@addto@macro\Gin@extensions{,.jpg}
\@namedef{Gin@rule@.jpg}#1{{eps}{.jpg.eps}{`convert #1 eps:#1.eps}}
% \DeclareGraphicsRule for .jpg
\g@addto@macro\Gin@extensions{,.gif}
\@namedef{Gin@rule@.gif}#1{{eps}{.gif.eps}{`convert #1 eps:#1.eps}}
% \DeclareGraphicsRule for .jpg
\g@addto@macro\Gin@extensions{,.png}
\@namedef{Gin@rule@.png}#1{{eps}{.png.eps}{`convert #1 eps:#1.eps}}
% \DeclareGraphicsRule for .jpg
\g@addto@macro\Gin@extensions{,.tif}
\@namedef{Gin@rule@.tif}#1{{eps}{.tif.eps}{`convert #1 eps:#1.eps}}

%%%%%%%%% DEUXIEME SOLUTION COMPILATION PDFLATEX
% \RequirePackage[pdftex]{graphicx}
% \RequirePackage[]{epstopdf}
% \g@addto@macro\Gin@extensions{,.ps}
% \@namedef{Gin@rule@.ps}#1{{pdf}{.pdf}{`epstopdf #1}}

% \RequirePackage[shell]{pdftricks}
% \begin{psinputs}
% \RequirePackage{pst-all} %% pstricks : outil pour faire des illustrations sous
%                          %% LaTeX
% \configure[pdfgraphic][rulesep=150pt]
% \end{psinputs}


%\ifthenelse{\boolean{thdoc}}
%{
%
%  \ifthenelse{\boolean{hdrdoc}}
%  {
%    \ClassError{memcril}{The options th and hdr are not compatible}{}
%  }{}
%  \ifthenelse{\boolean{mrdoc}}
%  {
%    \ClassError{memcril}{The options th and mr are not compatible}{}
%  }{}
%}
%{
%  \ifthenelse{\boolean{hdrdoc}}
%  {
%    \ifthenelse{\boolean{mrdoc}}
%    {
%      \ClassError{memcril}{The options hdr and mr are not compatible}{}
%    }{}
%  }
%  {
%    \ifthenelse{\boolean{mrdoc}}
%    {}{\setboolean{thdoc}{true}}
%  }
%}  

\ifthenelse{\value{nboption}=0}
  {
    \setboolean{thdoc}\stepcounter{nboption}
  }
  {
    \ifthenelse{\value{nboption}>1}
    {\ClassError{memcril}{No more than one option among m1, m2ia, m2ili, m2ilj, th and hdr}{}}
    {}
  }

\ifthenelse{\boolean{optionedoc}}
{
  %%% OPTION LINK
  % Si l'on veut produire une version PDF passer par PS puis PDF 
  % Permet d'obtenir des liens dans la version pdf
  \RequirePackage[ps2pdf,
  % linktocpage,
  backref,
  colorlinks=true,
  breaklinks=true,
  linkcolor=blue,
  citecolor=blue,
  pageanchor=true]{tlhypref}
  
  % Si on veut des mini-tables des matieres (utiliser minitoc-hyper 
  % en conjonction avec tlhypref) :
  \RequirePackage[french]{minitoc-hyper}
  \bibliographystyle{memcril-short}
}
{
  %%% OPTION IMPRESSION OPTION PAR DÉFAUT
  \RequirePackage[french]{minitoc}
  \renewcommand*{\@cite@ofmt}[1]{#1}
  \bibliographystyle{memcril-long}
}


\renewcommand{\@NancyIhe@d}{
  \UseEntryFont{ThesisFirstPageHead}\noindent
  \centerline{Facult\'e des Sciences Jean Perrin -- Universit\'e d'Artois}%
  \par\nointerlineskip
  \vskip1mm
  \noindent\hrulefill%\\
  % D\'epartement de Formation Doctorale en Informatique
  % \hfill\'Ecole Doctorale IAE $+$ M\par
}

\newcommand\CRILLogo{\includegraphics[height=1.8cm]{cril}}

\newcommand\ArtoisLogo{\includegraphics[height=1.8cm]{artois}}

\newcommand\CNRSLogo{\includegraphics[height=1.8cm]{cnrs}}

\renewcommand{\@ThesisFirstPageHead}{
  \vskip-1.75cm

  \noindent\ArtoisLogo\hfill\CNRSLogo\hfill\CRILLogo
  
  \vskip2mm
  \hrule
}

\newcommand{\@ThesisFirstPageFoot@CRIL}{
  \hrule
  \vskip2mm
  \begin{center}
    \UseEntryFont{ThesisFirstPageFoot}
    {\sc {\bfseries C}entre de {\bfseries R}echerche en {\bfseries I}nformatique
      de {\bfseries L}ens -- CNRS UMR 8188}\\ 
    Universit\'e d'Artois, rue Jean Souvraz, S.P. 18 F-62307, Lens
    Cedex France\\ 
    Secr\'etariat : T\'el.: +33 (0)3 21 79 17 23 -- Fax : +33 (0)3 21 79 17
    70\\
    {\tt http://www.cril.univ-artois.fr} 
  \end{center}
  \vspace*{-1.25cm}
}

\ThesisFirstPageFoot{\@ThesisFirstPageFoot@CRIL}

\let\Sorte\ThesisKind
\let\Pour\ThesisInOrderToGet
\let\Date\ThesisPresentedThe
\let\Titre\ThesisTitle
\let\Auteur\ThesisAuthor
\let\MakeTitlePage\MakeThesisTitlePage

\Titre{Le titre}
\Auteur{Moi}
\Date{présentée et soutenue publiquement le ...}
\Pour{en vue de l'obtention du}

\NewJuryCategory{Membre}{}{}
\NewJuryCategory{Encadrant}{\textit{Encadrant :}}{\textit{Encadrants :}}

 
\ifthenelse{\boolean{thdoc}}
{
  \ThesisDiploma{
    {\UseEntryFont{ThesisDiploma}%
      Doctorat de l'Universit\'e d'Artois\\[3mm]
      {\UseEntryFont{ThesisSpecialty}(Sp\'ecialit\'e Informatique)}
    }
  }
  \Sorte{TH\`ESE}
}{}


\ifthenelse{\boolean{hdrdoc}}
{
  \Sorte{{\UseEntryFont{ThesisDiploma}M\'emoire d'}\\[3mm]
    Habilitation \`a Diriger des Recherches\\[3mm]
    {\UseEntryFont{ThesisDiploma}(Sp\'ecialit\'e Informatique)}\\[1.5cm]
    Universit\'e d'Artois\vspace*{-1cm}
  }
  \ThesisDiploma{}
  \Pour{\vspace*{-2cm}}
}{}


\ifthenelse{\boolean{m1doc}}
{
  \Sorte{Travail d'\'Etudes et de Recherche}

  \ThesisDiploma{\UseEntryFont{ThesisDiploma}%
     Master Informatique de l'Universit\'e d'Artois\\[3mm]}

  \Pour{pour l'obtention de la première année du}
  \Date{soutenu le ...}
  \ThesisJuryTitle{}
}{}


\ifthenelse{\boolean{m2iadoc}}
{
  \Sorte{M\'EMOIRE}
  \ThesisDiploma{\UseEntryFont{ThesisDiploma}%
    Master Informatique de l'Universit\'e d'Artois\\[3mm]

  \UseEntryFont{ThesisSpecialty} Parcours Intelligence Artificielle}
  \Pour{pour l'obtention du}
  \Date{soutenu le ...}
  \ThesisJuryTitle{}
}{}


\ifthenelse{\boolean{m2ilidoc}}
{
  \Sorte{M\'EMOIRE}
  \ThesisDiploma{\UseEntryFont{ThesisDiploma}%
    Master Informatique de l'Universit\'e d'Artois\\[3mm]

  \UseEntryFont{ThesisSpecialty} Parcours 
    Ingénierie Logicielle pour l'Internet}

  \Pour{pour l'obtention du}
  \Date{soutenu le ...}
  \ThesisJuryTitle{}
}{}


\ifthenelse{\boolean{m2iljdoc}}
{
  \Sorte{M\'EMOIRE}
  \ThesisDiploma{\UseEntryFont{ThesisDiploma}%
    Master Informatique de l'Universit\'e d'Artois\\[3mm]

  \UseEntryFont{ThesisSpecialty} Parcours 
    Ingénierie Logicielle pour les Jeux}

  \Pour{pour l'obtention du}
  \Date{soutenu le ...}
  \ThesisJuryTitle{}
}{}



%%%%%%%%%% Réactivation de la présentation longue des entêtes de chapitre
\newcommand{\YesChapterHead}{\renewcommand{\@chapter@title@head}{\@chapapp}}

%%%%%%%%%% Bizarrerie sur les annexes ==> redéfinition de annexes
\renewcommand{\Annexes}{\part*{Annexes}\cleardoublepage}

%%%%%%%%%% Biblio francisé
\newcommand{\andname}{et}
\newcommand{\editorname}{\'editeur}
\newcommand{\editornames}{\'editeurs}
\newcommand{\volumename}{volume}
\newcommand{\Volumename}{Volume}
\newcommand{\ofname}{de}
\newcommand{\numbername}{num\'ero}
\newcommand{\Numbername}{Num\'ero}
\newcommand{\inname}{dans}
\newcommand{\Inname}{Dans}
\newcommand{\editionname}{\'edition}
\newcommand{\pagesname}{pages}
\newcommand{\technicalreportname}{Rapport technique}
\newcommand{\revisionname}{R\'evision}
\newcommand{\janname}{janvier}
\newcommand{\febname}{f\'evrier}
\newcommand{\marname}{mars}
\newcommand{\aprname}{avril}
\newcommand{\mayname}{mai}
\newcommand{\junname}{juin}
\newcommand{\julname}{juillet}
\newcommand{\augname}{ao\^ut}
\newcommand{\sepname}{septembre}
\newcommand{\octname}{octobre}
\newcommand{\novname}{novembre}
\newcommand{\decname}{d\'ecembre}

\endinput
